# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::DevTestLabs::Mgmt::V2018_09_15
  module Models
    #
    # The properties of a resource cost item.
    #
    class LabResourceCostProperties

      include MsRestAzure

      # @return [String] The name of the resource.
      attr_accessor :resourcename

      # @return [String] The unique identifier of the resource.
      attr_accessor :resource_uid

      # @return [Float] The cost component of the resource cost item.
      attr_accessor :resource_cost

      # @return [String] The logical resource type (ex. virtualmachine,
      # storageaccount)
      attr_accessor :resource_type

      # @return [String] The owner of the resource (ex. janedoe@microsoft.com)
      attr_accessor :resource_owner

      # @return [String] The category of the resource (ex. Premium_LRS,
      # Standard_DS1)
      attr_accessor :resource_pricing_tier

      # @return [String] The status of the resource (ex. Active)
      attr_accessor :resource_status

      # @return [String] The ID of the resource
      attr_accessor :resource_id

      # @return [String] The ID of the external resource
      attr_accessor :external_resource_id


      #
      # Mapper for LabResourceCostProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LabResourceCostProperties',
          type: {
            name: 'Composite',
            class_name: 'LabResourceCostProperties',
            model_properties: {
              resourcename: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourcename',
                type: {
                  name: 'String'
                }
              },
              resource_uid: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceUId',
                type: {
                  name: 'String'
                }
              },
              resource_cost: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceCost',
                type: {
                  name: 'Double'
                }
              },
              resource_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceType',
                type: {
                  name: 'String'
                }
              },
              resource_owner: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceOwner',
                type: {
                  name: 'String'
                }
              },
              resource_pricing_tier: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourcePricingTier',
                type: {
                  name: 'String'
                }
              },
              resource_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceStatus',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceId',
                type: {
                  name: 'String'
                }
              },
              external_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'externalResourceId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
